package edu.wpi.aipaint.agentselection;

import java.awt.BorderLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JTextArea;
import javax.swing.JToolBar;

import edu.wpi.aipaint.main.MainWindow;
import edu.wpi.aipaint.main.NullGlassPane;
import edu.wpi.aipaint.main.NullMouseMotionListener;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.PipelineModule;
import edu.wpi.aipaint.pipeline.PipelineSubModule;
import edu.wpi.aipaint.util.Vector2;

public class AgentSelectionModule implements PipelineSubModule, MouseListener {
	PipelineModule parent;
	MainWindow window;

	@Override
	public void setPipelineParent(PipelineModule parent) {
		this.parent = parent;
	}

	@Override
	public void activate(MainWindow window) {
		this.window = window;
		window.getSideBar().add(makeToolBar(), BorderLayout.NORTH);
		window.setModuleGlassPane(new NullGlassPane());
		window.setModuleMouseListener(this);
		window.setModuleMouseMotionListener(new NullMouseMotionListener());
	}
	
	private JToolBar makeToolBar() {
		JToolBar toolBar = new JToolBar(JToolBar.VERTICAL);
		toolBar.setFloatable(false);
		
		JTextArea instructions = new JTextArea();
		instructions.setEditable(false);
		instructions.setText("Click on an agent to begin editing its AI.");
		instructions.setLineWrap(true);
		instructions.setWrapStyleWord(true);
		toolBar.add(instructions);
		
		return toolBar;
	}

	@Override
	public void deactivate() { }

	@Override
	public String getName() {
		return "Agent Selection Module";
	}

	@Override
	public void tick() { }

	@Override
	public void mouseClicked(MouseEvent e) { }

	@Override
	public void mouseEntered(MouseEvent e) { }

	@Override
	public void mouseExited(MouseEvent e) { }

	@Override
	public void mousePressed(MouseEvent e) { }

	@Override
	public void mouseReleased(MouseEvent e) {
		Vector2 click = window.getWorldSpacePoint(new Vector2(e.getX(), e.getY()));
		
		AIAgent agent = window.getAIAgentAt(click);
		
		if (agent != null)
		{
			parent.setAIAgent(agent);
			System.out.println("Selected agent " + agent.toString() + ".");
		}
		else
			System.out.println("Did not select an agent.");
	}
}
