package edu.wpi.aipaint.ai;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.values.Value;

public class BTDefaultRootNode implements IBTDecisionNode, IBTLeafNode {
	public BehaviorTree bt;
	private Action action;
	
	public BTDefaultRootNode(BehaviorTree bt){
		this.bt = bt;
		this.action = new Action() {

			@Override
			public Action execute(AIAgent agent) {
				// TODO Auto-generated method stub
				return null;
			}
			
		};
	}

	public BTDefaultRootNode(Action action, BehaviorTree bt) {
		this.bt = bt;
		this.action = action;
	}

	public IBTNode getChild(WorldState p_ws) {
		return new BTLeafNode(this, this.action);
	}

	public Action evaluate(WorldState p_ws) {
		return this.action;
	}

	public String treePrint(int p_depth) {
		String ret = "";
		for (int i = 0; i < p_depth; i++) {
			ret += "|  ";
		}
		ret += "DefaultRootNode: [" + this.action.toString() + "]\n";
		return ret;
	}

	public String toXML() {
		throw new UnsupportedOperationException();
	}

	@Override
	public IBTNode getChild(Value p_attributeValue) {
		return new BTLeafNode(this, this.action);
	}

	public IBTDecisionNode attachNextChild(	IBTNode p_child,
											WorldState p_ws) {
		if (p_child instanceof IBTLeafNode) {
			p_child = new BTDefaultRootNode(((IBTLeafNode) p_child).getAction(),
					this.bt);
		}
		this.bt.setRoot((IBTDecisionNode) p_child);
		return null;
	}

	@Override
	public IBTDecisionNode getParent() {
		return null;
	}

	@Override
	public void setParent(IBTDecisionNode parent) {
		// No action
	}

	@Override
	public Action getAction() {
		return this.action;
	}

	@Override
	public List<? extends Value> getDecisionSlots() {
		return new ArrayList<Value>();
	}

	@Override
	public Attribute getAttribute() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Value getLowerBound(IBTNode p_child) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Value getUpperBound(IBTNode p_child) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IBTDecisionNode insertChild(	Value p_value,
										IBTNode p_child) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IBTNode removeChild(IBTNode p_child) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IBTNode removeChild(Value p_value) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void mergeChildren(IBTDecisionNode p_other)
			throws DiscourseException {
		// TODO Auto-generated method stub

	}

	@Override
	public int getChildCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public Iterator<? extends IBTNode> getChildrenIterator() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Value getValue(IBTNode child) {
		// TODO Auto-generated method stub
		return null;
	}
}