package edu.wpi.aipaint.ai;

import java.util.Iterator;
import java.util.List;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.values.Value;

public interface IBTDecisionNode extends IBTNode {
	List<? extends Value> getDecisionSlots();

	Attribute getAttribute();
	
	Value getLowerBound(IBTNode p_child);
	Value getUpperBound(IBTNode p_child);
	IBTNode getChild(Value p_attributeValue);
	
	IBTDecisionNode attachNextChild(IBTNode p_child, WorldState p_ws) throws DiscourseException;
	IBTDecisionNode insertChild(Value p_value, IBTNode p_child);
	IBTNode removeChild(IBTNode p_child);
	IBTNode removeChild(Value p_value);
	
	void mergeChildren(IBTDecisionNode p_other) throws DiscourseException;
	
	Action evaluate(WorldState p_ws);
	
	IBTNode getChild(WorldState p_ws);
	int getChildCount();
	Iterator<? extends IBTNode> getChildrenIterator();
	
	Value getValue(IBTNode child);
}
