package edu.wpi.aipaint.attributes;

import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.values.Value;


/**
 * Returns the same Value every time it is evaluated, ignoring
 * the WorldState.
 */
public class ConstantAttribute implements Attribute {
	Value value;
	
	public ConstantAttribute(Value value)
	{
		this.value = value;
	}
	
	public void setValue(Value value)
	{
		this.value = value;
	}
	
	@Override
	public String toString()
	{
		return "ConstantAttribute [Value " + value.toString() + "]";
	}

	@Override
	public Value evaluate(WorldState worldState) {
		return value;
	}
}
