package edu.wpi.aipaint.attributes;

import edu.wpi.aipaint.main.WorldFeature;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.values.Value;


/**
 * When evaluated, looks up the value of a particular WorldFeature.
 */
public class PassThroughAttribute implements Attribute {
	private WorldFeature feature;
	
	public PassThroughAttribute(WorldFeature feature)
	{
		this.feature = feature;
	}
	
	@Override
	public String toString()
	{
		return "PassThroughAttribute [Feature " + feature.getName() + "]";
	}

	@Override
	public Value evaluate(WorldState worldState) {
		return worldState.getValue(feature);
	}
}
