package edu.wpi.aipaint.attributes;

import edu.wpi.aipaint.main.WorldFeature;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Value;
import edu.wpi.aipaint.values.Vector2Wrapper;

public class PoseableOffsetAttribute implements Attribute {
	private WorldFeature basePoseable;
	private WorldFeature baseOrientation;
	private float offsetAngle;
	private float distance;
	
	public PoseableOffsetAttribute(WorldFeature basePoseable, WorldFeature baseOrientation, float offsetAngle, float distance) {
		this.basePoseable = basePoseable;
		this.baseOrientation = baseOrientation;
		this.offsetAngle = offsetAngle;
		this.distance = distance;
	}
	
	@Override
	public Value evaluate(WorldState worldState) {
		Vector2 pos = ((Vector2Wrapper)(worldState.getValue(basePoseable))).getValue();
		Vector2 orient = ((Vector2Wrapper)(worldState.getValue(baseOrientation))).getValue();
		Vector2 direction = orient.rotate(Vector2.ZERO, offsetAngle);
		return new Vector2Wrapper(pos.add(direction.multiply(distance)));
	}

}
