package edu.wpi.aipaint.directo;

import edu.wpi.aipaint.ai.BTLeafNode;
import edu.wpi.aipaint.ai.BehaviorTree;
import edu.wpi.aipaint.ai.DiscourseException;
import edu.wpi.aipaint.ai.IBTNode;
import edu.wpi.aipaint.directo.BTAIController;
import edu.wpi.aipaint.directo.DirectoProgram;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.AIController;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.pipeline.NullAction;

public class BTAIController implements AIController {

	private AIAgent m_agent;
	private BehaviorTree m_ai;

	public BTAIController(AIAgent agent) {
		this.m_agent = agent;
		this.m_ai = new BehaviorTree(new NullAction());
	}

	public BTAIController(AIAgent agent, BehaviorTree behaviorTree) {
		this.m_agent = agent;
		this.m_ai = behaviorTree;
	}

	public Action evaluate(WorldState ws) {
		return ((BTLeafNode) this.m_ai.getActiveNode(ws)).getAction();
	}

	public BehaviorTree getBehaviorTree() {
		return this.m_ai;
	}

	public AIAgent getM_agent() {
		return m_agent;
	}

	public void runDirectoProgram(DirectoProgram directoProgram) {
		while (directoProgram.hasDirections()) {
			try {
				directoProgram.getDirection().execute(this.m_ai.getRoot(),
						directoProgram.getWorldState());
			} catch (DiscourseException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	public void runDirectoProgram(String directoProgram) {
		// TODO Auto-generated method stub

	}

	public String toString() {
		return "AIController [Agent=\"" + this.m_agent + "\"; AI=\""
				+ this.m_ai + "\"";
	}

	public IBTNode[] getActivePath(WorldState currentState) {
		return this.m_ai.getActivePath(currentState);
	}
}
