package edu.wpi.aipaint.main;

import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.List;

import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.util.Vector2;

public interface Game {
	public Poseable getPoseableAt(Vector2 worldSpacePoint);
	
	public List<Poseable> getPoseablesCollidingWith(Vector2 worldSpaceCenter, float worldSpaceRadius);

	public void tick(int gameTime);

	public void draw(int gameTime);

	public Vector2 getWorldSpacePoint(Vector2 screenSpacePoint);
	
	public Vector2 getScreenSpacePoint(Vector2 worldSpacePoint);

	public void aiPaintInit();
	
	public AIAgent getAIAgentAt(Vector2 worldSpacePoint);

	public MouseListener getMouseListener();
	public MouseMotionListener getMouseMotionListener();
	public KeyListener getKeyboardListener();

	public WorldState getCurrentWorldState();
}
