package edu.wpi.aipaint.main;

/**
 * Singleton class that holds a reference to a Game and provides its 
 * WorldStates to all who would desire them.
 */
public class GameKeeper {
	private static GameKeeper instance;
	
	private Game game;
	
	private GameKeeper()
	{
	}
	
	public static GameKeeper GetInstance()
	{
		if (instance == null)
			instance = new GameKeeper();
		
		return instance;
	}
	
	/**
	 * Sets the Game kept.
	 * @param game
	 */
	public void setGame(Game game)
	{
		this.game = game;
	}
	
	/**
	 * Returns the Game's current WorldState.
	 * Requires that setGame have been called beforehand.
	 * @return
	 */
	public WorldState getCurrentWorldState()
	{
		return game.getCurrentWorldState();
	}
}
