package edu.wpi.aipaint.main;

import java.util.LinkedList;

/**
 * Represents a group of Poseables that are related in some meaningful way.
 */
public class Group {
	String name;
	LinkedList<Poseable> members;
	
	public Group(String name)
	{
		this.name = name;
		this.members = new LinkedList<Poseable>();
	}
	
	public String getName()
	{
		return name;
	}
	
	public void addMember(Poseable member)
	{
		members.add(member);
	}
	
	public Iterable<Poseable> getMembers()
	{
		return members;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		Group other = (Group) obj;
		return other.getName().equals(name);
	}
	
	@Override
	public int hashCode()
	{
		return name.hashCode();
	}
	
	@Override
	public String toString()
	{
		return "Group [" + name + "]";
	}
}
