package edu.wpi.aipaint.main;

import java.util.List;

public interface IQuestion {
	
	/**
	 * Ask a question whose answer is one of a finite number. Returns the answer as a string.
	 * Should assume total control of the program, since it needs to return the answer.
	 * Having an asynchronous question asking system would take more work
	 * @param question
	 * @param answers
	 * @return One of the strings contained in "answers", the one picked by the provider of this class's answers
	 * @throws Exception - Some problem happened in the way of answering the question and no answer was found
	 */
	public String askMultipleChoiceQuestion(String question, List<String> answers) throws Exception;
}
