package edu.wpi.aipaint.main;

import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Value;

/**
 * Represents an object on whose state an AIPaint agent may make decisions.
 * This object's state may be posed during design time using the AIPaint UI. 
 */
public interface Poseable {
	public void moveTo(Vector2 worldSpacePoint);
	public Vector2 getPosition();
	public WorldFeature getFeature();
	public <ValueType extends Value> ValueType getFeatureValue();
	
	public Iterable<Group> getGroups();
	
	public Vector2 getOrientation();
	
	public WorldFeature getOrientationFeature();
	public <ValueType extends Value> ValueType getOrientationFeatureValue();
}
