package edu.wpi.aipaint.main;

public class Ticker extends Thread {

    private MainWindow window;
    private int delay;
    int prevTime;

    public Ticker(MainWindow window, int fps) {
        this.window = window;
        delay = 1000 / fps;
    }

	public void run() {
		prevTime = (int) System.currentTimeMillis();
        while (Thread.currentThread() == window.getTicker()) {
            try {
                Thread.sleep(delay);

            } catch (InterruptedException e) {
                break;
            }
            
            int currTime = (int) System.currentTimeMillis();
            window.tick(currTime - prevTime);
            prevTime = currTime;
            window.draw();
            //window.requestFocus();
        }
    }
}