package edu.wpi.aipaint.pipeline;

import edu.wpi.aipaint.ai.IBTNode;
import edu.wpi.aipaint.directo.DirectoProgram;
import edu.wpi.aipaint.main.WorldState;

public interface AIController {
	
	/**
	 * Evaluates the behavior tree to see the resultant action
	 * @param ws WorldState to evaluate
	 * @return Action at the resultant leaf node
	 */
	Action evaluate(WorldState ws);
	
	/**
	 * Applies a directo program to 
	 * @param directoProgram
	 */
	public void runDirectoProgram(String directoProgram);
	
	/**
	 * Applies a directo program to 
	 * @param directoProgram
	 */
	public void runDirectoProgram(DirectoProgram directoPrgram);

	IBTNode[] getActivePath(WorldState currentState);
}
