package edu.wpi.aipaint.pipeline;

import edu.wpi.aipaint.directo.DirectoProgram;


/**
 * Submodule of PipelineModule that takes Directions and applies them to an
 * AI data representation.
 */
public interface AIProcessor extends PipelineSubModule {
	/**
	 * Applies the given List of Directions to the Pipeline's
	 * AI data representation.
	 * @param program
	 */
	void applyDirectioProgram(DirectoProgram program);
	
	/**
	 * Applies complementary Directions to the AI data representation to 
	 * undo the effects of the last input List of Directions.  Several 
	 * inputs may be undone in sequence. 
	 */
	void undo();
	
	/**
	 * Applies Directions to the AI data representation to redo the last 
	 * undone input List of Directions.  Several "undo" actions may be
	 * redone in sequence.
	 */
	void redo();
}
