package edu.wpi.aipaint.pipeline;

import edu.wpi.aipaint.ai.IBTNode;
import edu.wpi.aipaint.ai.DiscourseException;
import edu.wpi.aipaint.main.WorldState;

/**
 * Defines a modification to an AI data representation.
 */
public interface Direction {
	/**
	 * @return A Direction object that can be applied to an AI data 
	 * representation to undo the effects of this Direction.
	 */
	Direction generateComplement();
	
	//FIXME: References BTNodes, should be in btai
	/**
	 * Executes this Direction on the given behavior tree node.
	 * @return the complement of the action just executed
	 * @throws DiscourseException if the tree is not simple
	 */
	Direction execute(IBTNode parent, WorldState ws) throws DiscourseException;
}
