package edu.wpi.aipaint.pipeline;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

/**
 * A keyboard and mouse listener that proxies for other input
 * listeners stored inside of it.   
 */
public class PipelineInputListener implements KeyListener, MouseListener, MouseMotionListener {
	KeyListener keyListener;
	MouseListener mouseListener;
	MouseMotionListener mouseMotionListener;
	
	public PipelineInputListener()
	{
	}
	
	public PipelineInputListener(KeyListener keyListener, 
			MouseListener mouseListener, 
			MouseMotionListener mouseMotionListener)
	{
		this.keyListener = keyListener;
		this.mouseListener = mouseListener;
		this.mouseMotionListener = mouseMotionListener;
	}
	
	public KeyListener getKeyListener()
	{
		return keyListener;
	}
	
	public MouseListener getMouseListener()
	{
		return mouseListener;
	}
	
	public MouseMotionListener getMouseMotionListener()
	{
		return mouseMotionListener;
	}
	
	public void setKeyListener(KeyListener keyListener)
	{
		this.keyListener = keyListener;
	}
	
	public void setMouseListener(MouseListener mouseListener)
	{
		this.mouseListener = mouseListener;
	}
	
	public void setMouseMotionListener(MouseMotionListener mouseMotionListener)
	{
		this.mouseMotionListener = mouseMotionListener;
	}
	
	// Proxy methods
	
	@Override
	public void keyPressed(KeyEvent arg0) {
		keyListener.keyPressed(arg0);
	}

	@Override
	public void keyReleased(KeyEvent arg0) {
		keyListener.keyReleased(arg0);
	}

	@Override
	public void keyTyped(KeyEvent arg0) {
		keyListener.keyTyped(arg0);
	}

	@Override
	public void mouseClicked(MouseEvent arg0) {
		mouseListener.mouseClicked(arg0);
	}

	@Override
	public void mouseEntered(MouseEvent arg0) {
		mouseListener.mouseEntered(arg0);
	}

	@Override
	public void mouseExited(MouseEvent arg0) {
		mouseListener.mouseExited(arg0);
	}

	@Override
	public void mousePressed(MouseEvent arg0) {
		mouseListener.mousePressed(arg0);
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		mouseListener.mouseReleased(arg0);
	}

	@Override
	public void mouseDragged(MouseEvent arg0) {
		mouseMotionListener.mouseDragged(arg0);
	}

	@Override
	public void mouseMoved(MouseEvent arg0) {
		mouseMotionListener.mouseMoved(arg0);
	}
	
}
