package edu.wpi.aipaint.pipeline;

import edu.wpi.aipaint.util.UserObjectTreeNode;

/**
 * Submodule of PipelineModule that translates Statements of designer intention
 * and translates them into Directions for the modification of an AI data
 * representation.
 */
public interface StatementProcessor extends PipelineSubModule {
	/**
	 * Processes the given tree of Statements into Directions for the 
	 * modification of the current AI data representation.
	 * @param statementTree
	 */
	public void processStatements(UserObjectTreeNode<Statement> statementTree);
}
