package edu.wpi.aipaint.poseo;

import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseListener;

import edu.wpi.aipaint.main.MainWindow;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.util.Vector2;

public class PoseModeMouseListener extends MouseMotionAdapter implements MouseListener 
{
	private MainWindow mainWindow;
	
	Poseable activePosable;
	
	public PoseModeMouseListener(MainWindow mainWindow) {
		this.mainWindow = mainWindow;
	}
	
	@Override
	public void mouseClicked(MouseEvent arg0) {
		Poseable p = mainWindow.getPoseableAt(mainWindow.getWorldSpacePoint(new Vector2(arg0.getX(), arg0.getY())));
		if(p != null) {
			setActivePoseable(p);
		}
	}
	
	@Override
	public void mouseDragged(MouseEvent arg0) {
		moveActivePoseable(mainWindow.getWorldSpacePoint(new Vector2(arg0.getX(), arg0.getY())));
	}

	@Override
	public void mouseEntered(MouseEvent arg0) { }

	@Override
	public void mouseExited(MouseEvent arg0) { }

	@Override
	public void mousePressed(MouseEvent arg0) {
		setActivePoseable(mainWindow.getPoseableAt(mainWindow.getWorldSpacePoint(new Vector2(arg0.getX(), arg0.getY()))));		
		
	}

	@Override
	public void mouseReleased(MouseEvent arg0) {
		disableActivePoseable();
		
	}

	private void setActivePoseable(Poseable p) {
		activePosable = p;
		
	}

	private void moveActivePoseable(Vector2 worldSpacePoint) {
		if(activePosable != null)
			activePosable.moveTo(worldSpacePoint);		
	}

	private void disableActivePoseable() {
		activePosable = null;
		
	}
}
