package edu.wpi.aipaint.sketcho;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.Group;

/**
 * Provides Attributes capable of generalizing over particular Groups.
 */
public interface HeuristicFactory {
	/**
	 * Returns an Iterable containing all Attributes that are capable of 
	 * generalizing the given Group.
	 * @param group
	 * @return
	 */
	public Iterable<Attribute> getGeneralizingAttributes(Group group);
}
