package edu.wpi.aipaint.sketcho;

import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;

import javax.swing.JComponent;

import edu.wpi.aipaint.util.Line;
import edu.wpi.aipaint.util.Line.LineFonts;

@SuppressWarnings("serial")
public class SketchoGlassPane extends JComponent {
	Iterable<Line> lines;
	float lineWidth;
	
	public SketchoGlassPane() {
		lines = new ArrayList<Line>();
	}

	public void setLines(Iterable<Line> newLines) {
		lines = newLines;
	}
	
	public void setLineWidth(float value) {
		lineWidth = value;
	}
	
	@Override
	protected synchronized void paintComponent(Graphics g) {
		Graphics2D g2d = (Graphics2D)g;

		for(Line l : lines) {
			g2d.setColor(l.getColor());
			if(l.getFont() == LineFonts.solid)
				g2d.setStroke(new BasicStroke(
						lineWidth,
						BasicStroke.CAP_ROUND, 
					      BasicStroke.JOIN_ROUND));
			else {
				g2d.setStroke(new BasicStroke(
						  lineWidth,
					      BasicStroke.CAP_ROUND, 
					      BasicStroke.JOIN_ROUND, 
					      0, 
					      new float[] {12, 12}, 
					      0f));
			}
			g2d.drawLine((int) l.getPoint1().getX(), (int) l.getPoint1().getY(), 
					(int) l.getPoint2().getX(), (int) l.getPoint2().getY());
		}
	}
}
