package edu.wpi.aipaint.sketcho;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.pipeline.Action;

/**
 * Defines a factory for constructing SketchoStatement objects.
 */
public interface StatementFactory {
	/**
	 * Returns an instance of the SketchoStatement with the given name.
	 * @param statement
	 * @return
	 */
	public SketchoStatement getStatement(String statementName);
	
	/**
	 * Returns an instance of the SketchoStatement that produces the given 
	 * Action.
	 * @param actionProduced
	 * @return
	 */
	public SketchoStatement getStatement(Action actionProduced);
	
	/**
	 * Returns an instance of the SketchoStatement that produces a decision on
	 * the given Attribute.
	 * @param attributeProduced
	 * @return
	 */
	public SketchoStatement getStatement(Attribute attributeProduced);
}
