package edu.wpi.aipaint.util;

import java.util.Iterator;

public interface TreeNode {
	/**
	 * @return Iterator over this TreeNode's collection of child TreeNodes, or
	 * null if this TreeNode has no children.
	 */
	Iterator<? extends TreeNode> getChildren();
	
	/**
	 * @return The number of children belonging to this TreeNode.
	 */
	int getChildCount();
	
	/**
	 * @return The parent of this TreeNode, or null if this TreeNode 
	 * represents the root of a tree.
	 */
	TreeNode getParent();
	
	/**
	 * @return True if the node is a leaf node.
	 */
	boolean isLeaf();
}
