package edu.wpi.aipaint.values;



/**
 * Wraps the Boolean class for use as a Value in behavior tree decision nodes.
 */
public class BooleanWrapper implements Value {
	private Boolean value;

	public BooleanWrapper(Boolean value)
	{
		this.value = value;
	}
	
	public BooleanWrapper(boolean value)
	{
		this.value = value;
	}
	
	public Boolean getValue()
	{
		return value;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		BooleanWrapper other = (BooleanWrapper) obj;
		return other.getValue().equals(value);
	}
	
	@Override
	public int hashCode()
	{
		return value.hashCode();
	}
}
