package edu.wpi.aipaint.values;



/**
 * Wraps the Float class for use as a ContinuousValue in behavior tree 
 * decision nodes.
 */
public class FloatWrapper implements ContinuousValue {
	private Float value;
	
	public static final FloatWrapper MAX_VALUE = new FloatWrapper(Float.MAX_VALUE);
	public static final FloatWrapper ZERO = new FloatWrapper(0);
	
	public FloatWrapper(Float value)
	{
		this.value = value;
	}
	
	public FloatWrapper(float value)
	{
		this.value = value;
	}
	
	@Override
	public int compareTo(ContinuousValue o) {
		FloatWrapper other = (FloatWrapper) o;
		return value.compareTo(other.getValue());
	}
	
	public Float getValue()
	{
		return value;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		FloatWrapper other = (FloatWrapper) obj;
		return other.getValue().equals(value);
	}
	
	@Override
	public int hashCode()
	{
		return value.hashCode();
	}
	
	public String toString() {
		return "FloatWrapper [" + this.value + "]";
	}
}
