package edu.wpi.aipaint.values;

import edu.wpi.aipaint.util.Vector2;

/**
 * Wraps the Vector2 class for use as a Value in behavior tree decision nodes.
 */
public class Vector2Wrapper implements Value {
	private Vector2 value;
	
	public Vector2Wrapper(Vector2 value)
	{
		this.value = value;
	}
	
	public Vector2 getValue()
	{
		return value;
	}

	public String toString()
	{
		return "Vector2Wrapper [" + value.toString() + "]";
	}
	
	@Override
	public boolean equals(Object obj)
	{
		Vector2Wrapper other = (Vector2Wrapper) obj;
		return value.equals(other.getValue());
	}
	
	@Override
	public int hashCode()
	{
		return value.hashCode();
	}
}
