package edu.wpi.aipaint.worldspacepoint;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.util.Vector2;

/**
 * Represents some object with a location in world-space coordinates.
 * Under the covers, this object could be a point, a Poseable, a Vector2-valued
 * Attribute, etc.
 */
public interface WorldSpacePoint {
	public Vector2 getPoint();
	public float getX();
	public float getY();
	public boolean holdsPoseable();
	public Poseable getPoseable();
	public boolean holdsAttribute();
	public Attribute getAttribute();
	public Attribute translateToAttribute();
}
