package edu.wpi.aipaint.worldspacepoint;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.GameKeeper;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Vector2Wrapper;

/**
 * Represents a location in the form of a Vector2-valued Attribute.
 */
public class WorldSpacePointAttribute implements WorldSpacePoint {
	private Attribute point;
	
	public WorldSpacePointAttribute(Attribute point)
	{
		this.point = point;
	}

	@Override
	public Vector2 getPoint() {
		GameKeeper game = GameKeeper.GetInstance();
		Vector2Wrapper vector = (Vector2Wrapper) point.evaluate(game.getCurrentWorldState());
		return vector.getValue();
	}

	@Override
	public Poseable getPoseable() {
		return null;
	}

	@Override
	public float getX() {
		return getPoint().getX();
	}

	@Override
	public float getY() {
		return getPoint().getY();
	}

	@Override
	public boolean holdsPoseable() {
		return false;
	}

	@Override
	public Attribute getAttribute() {
		return point;
	}

	@Override
	public boolean holdsAttribute() {
		return true;
	}
	
	public Attribute translateToAttribute() {
		return point;
	}
	
	@Override
	public String toString()
	{
		return "WorldSpacePointAttribute [" + point.toString() + "]";
	}
}
