package edu.wpi.aipaint.worldspacepoint;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.attributes.PassThroughAttribute;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.util.Vector2;

/**
 * Represents a location in the form of a Poseable.
 * It goes where the Poseable goes!
 */
public class WorldSpacePointPoseable implements WorldSpacePoint {
	protected Poseable base;

	public WorldSpacePointPoseable(Poseable p) {
		base = p;
	}

	@Override
	public Vector2 getPoint() {
		return base.getPosition();
	}

	@Override
	public Poseable getPoseable() {
		return base;
	}

	@Override
	public float getX() {
		return base.getPosition().getX();
	}

	@Override
	public float getY() {
		return base.getPosition().getY();
	}

	@Override
	public boolean holdsPoseable() {
		return true;
	}

	public String toString() {
		return "WorldSpacePointPoseable [" + base.toString() + "]";
	}

	@Override
	public Attribute getAttribute() {
		return null;
	}

	@Override
	public boolean holdsAttribute() {
		return false;
	}
	
	public Attribute translateToAttribute() {
		return new PassThroughAttribute(base.getFeature());
	}
}
