package edu.wpi.aipaint.worldspacepoint;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.attributes.ConstantAttribute;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Vector2Wrapper;

/**
 * Represents a location in the form of a Vector2.
 */
public class WorldSpacePointVector implements WorldSpacePoint {
	protected Vector2 point;

	public WorldSpacePointVector(Vector2 point) {
		this.point = point;
	}

	@Override
	public Vector2 getPoint() {
		return point;
	}

	@Override
	public Poseable getPoseable() {
		return null;
	}

	@Override
	public float getX() {
		return point.getX();
	}

	@Override
	public float getY() {
		return point.getY();
	}

	@Override
	public boolean holdsPoseable() {
		return false;
	}

	public String toString() {
		return "WorldSpacePointVector [" + this.getX() + "," + this.getY()
				+ "]";
	}

	@Override
	public Attribute getAttribute() {
		return null;
	}

	@Override
	public boolean holdsAttribute() {
		return false;
	}
	
	public Attribute translateToAttribute() {
		return new ConstantAttribute(new Vector2Wrapper(point));
	}
}
