package actions;

import java.awt.Point;

import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.util.Vector2;

public class GoAwayFromPoseableAction implements MoveAction {
	private Poseable target;

	public Poseable getTarget() {
		return target;
	}

	public GoAwayFromPoseableAction(Poseable target) {
		this.target = target;
	}

	@Override
	public Action execute(AIAgent agent) {
		return null;
	}

	@Override
	public Point getDestination(AIAgent agent, WorldState worldState) {
		Vector2 targetloc = this.target.getPosition();
		Vector2 agentloc = agent.getPosition();

		float dx = agentloc.getX() - targetloc.getY();
		float dy = agentloc.getY() - targetloc.getY();

		return new Point((int) (agentloc.getX() + dx),
				(int) (agentloc.getY() + dy));
	}
}
