package actions;

import java.awt.Point;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Vector2Wrapper;

/**
 * An Action that moves an AIAgent toward the Vector2 value of a particular 
 * Attribute. 
 */
public class GoToAttributeAction implements MoveAction {
	private Attribute target;
	
	public GoToAttributeAction()
	{
	}
	
	public GoToAttributeAction(Attribute target)
	{
		this.target = target;
		System.out.println(target + " Is the target");
	}
	
	public void setTarget(Attribute target)
	{
		this.target = target;
	}
	
	public Attribute getTarget()
	{
		return target;
	}

	@Override
	public Point getDestination(AIAgent agent, WorldState worldState) {
		Vector2 targetValue = ((Vector2Wrapper) target.evaluate(worldState)).getValue();
		return new Point((int)targetValue.getX(), (int)targetValue.getY());
	}

	@Override
	public Action execute(AIAgent agent) {
		return null;
	}

	@Override
	public String toString()
	{
		return "GoToWorldSpacePointAction [" + target.toString() + "]";
	}
}
