package actions;

import java.awt.Point;

import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.main.WorldState;
import edu.wpi.aipaint.pipeline.AIAgent;
import edu.wpi.aipaint.pipeline.Action;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Vector2Wrapper;

public class GoTwiceAsFarAttributeAction implements MoveAction {
	private Attribute start;
	private Attribute end;
	
	public GoTwiceAsFarAttributeAction(Attribute start, Attribute end) {
		this.start = start;
		this.end = end;
	}
	
	@Override
	public Action execute(AIAgent agent) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Point getDestination(AIAgent agent, WorldState worldState) {
		Vector2 startVector = ((Vector2Wrapper) start.evaluate(worldState)).getValue();
		Vector2 endVector = ((Vector2Wrapper) end.evaluate(worldState)).getValue();
		Vector2 displacement = endVector.subtract(startVector);
		Vector2 target = startVector.add(displacement.multiply(2));
		return new Point((int)target.getX(), (int)target.getY());
	}
	
	public Attribute getStart() {
		return start;
	}
	
	public Attribute getEnd() {
		return end;
	}

}
