package aiPaintPacMan;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import edu.wpi.aipaint.agentselection.AgentSelectionModule;
import edu.wpi.aipaint.ai.BTAIModule;
import edu.wpi.aipaint.directo.BTDirectoModule;
import edu.wpi.aipaint.discourse.PopupQuestionAsker;
import edu.wpi.aipaint.main.MainWindow;
import edu.wpi.aipaint.main.Module;
import edu.wpi.aipaint.pipeline.PipelineModule;
import edu.wpi.aipaint.shapedetector.Point;
import edu.wpi.aipaint.shapedetector.Recognizer;
import edu.wpi.aipaint.sketcho.SketchoModule;

public class PacManForPaintMain {
	private static PipelineModule pipeline;

	public static void main(String[] args) {
		Recognizer r = new Recognizer(false);
		Point[][] goTwiceAsFarPoints = 
		{{new Point(0, 10), new Point(20, 10)},
		 {new Point(0, -10), new Point(20, -10)},
		 {new Point(0, 0), new Point(20, 0)},
		 {new Point(0, 10), new Point(0, -10)},
		};
		
		Point[] controlPoints = {new Point(0, 0), new Point(20, 0)};
		
		r.AddMultistroke("GoTwiceAsFar", false, goTwiceAsFarPoints, controlPoints);
		
		ArrayList<Module> modules = new ArrayList<Module>();
		pipeline = new PipelineModule(new AgentSelectionModule(), 
				new SketchoModule(new PacManStatementFactory(), new PacManHeuristicFactory(), r), 
				new BTDirectoModule(), new BTAIModule());
		modules.add(pipeline);
		MainWindow mw = new MainWindow(new AIPaintPacMan(), modules);
		mw.addWindowListener(new WindowAdapter() {

			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}

			;
		});

		PopupQuestionAsker disco = new PopupQuestionAsker(mw);
		mw.setDialogueHandler(disco);

		mw.init();
		// mw.setResizable(false);
		mw.pack();

		// mw.setSize(609, 450 + 20); // add 20, seems enough for the Frame
		// title,

		mw.setVisible(true);
		mw.start(40);
	}
	
	public static PipelineModule getPipelineModule()
	{
		return pipeline;
	}
}
