package aiPaintPacMan;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import actions.GoTwiceAsFarAttributeAction;

import edu.wpi.aipaint.ai.BTLeafNode;
import edu.wpi.aipaint.attributes.Attribute;
import edu.wpi.aipaint.directo.AttachChildDirection;
import edu.wpi.aipaint.pipeline.Direction;
import edu.wpi.aipaint.sketcho.SketchoActionStatement;
import edu.wpi.aipaint.util.Line;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.worldspacepoint.WorldSpacePoint;

public class PacManGoTwiceAsFarSketchoActionStatement extends SketchoActionStatement {

	@Override
	public List<Direction> translate() {
		List<Direction> translation = new LinkedList<Direction>();
		Attribute start = controlPoint1.translateToAttribute();
		Attribute end = controlPoint2.translateToAttribute();
		BTLeafNode moveToActionNode = new BTLeafNode(null, new GoTwiceAsFarAttributeAction(start, end));
		AttachChildDirection addActionNode = new AttachChildDirection(moveToActionNode);
		
		translation.add(addActionNode);

		return translation;
	}

	@Override
	public Iterable<WorldSpacePoint> getGeneralizableControlPoints() {
		return new LinkedList<WorldSpacePoint>();
	}

	@Override
	public void setGeneralizableControlPoint(WorldSpacePoint point, int index) {
		//Do nothing
	}

	@Override
	public Iterable<Line> getDrawLines() {
		float separation = translator.screenSpaceToWorldSpace(new Vector2(10, 0)).subtract(translator.screenSpaceToWorldSpace(new Vector2(0, 0))).getMagnitude();
		Vector2 cp1 = controlPoint1.getPoint();
		Vector2 cp2 = controlPoint2.getPoint();
		
		Vector2 direction = cp2.subtract(cp1);
		float length = direction.getMagnitude();
		direction = direction.normalize();
		Vector2 normal = direction.rotate(Vector2.ZERO, 90);
		Vector2 start1 = cp1.add(normal.multiply(separation));
		Vector2 start2 = cp1.add(normal.multiply(-separation));
		Vector2 end1 = start1.add(direction.multiply(length * .8f));
		Vector2 end2 = start2.add(direction.multiply(length * .8f));
		
		Line[] drawLines = new Line[6];
		drawLines[0] = new Line(start1, end1, mainColor);
		drawLines[1] = new Line(start2, end2, mainColor);
		drawLines[2] = new Line(cp1, cp2, mainColor);
		drawLines[3] = new Line(cp2, end1, mainColor);
		drawLines[4] = new Line(cp2, end2, mainColor);
		drawLines[5] = new Line(start1, start2, mainColor);
		return Arrays.asList(drawLines);
	}

	@Override
	public void doubleClick(Vector2 worldSpacePoint) {
		// TODO Auto-generated method stub

	}

}
