package aiPaintPacMan;

import java.util.LinkedList;

import pacman.Fruit;
import pacman.GameModel;
import edu.wpi.aipaint.main.Game;
import edu.wpi.aipaint.main.Group;
import edu.wpi.aipaint.main.GroupManager;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.main.WorldFeature;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Value;
import edu.wpi.aipaint.values.Vector2Wrapper;

public class PoseableFruit extends Fruit implements Poseable, AiPacmanInitializable {
	private WorldFeature position, orientation;
	
	private LinkedList<Group> groups;
	private float width, height;

	public PoseableFruit(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddleX) {
		super(gameModel, type, startX, startY, bMiddleX);
		position = new WorldFeature("PoseableFruitPosition");
		orientation = new WorldFeature("PoseableFruiteOrientation");

		groups = new LinkedList<Group>();
		GroupManager groupManager = GroupManager.GetInstance();
		groups.add(groupManager.registerPoseable(this, "fruit"));
		groups.add(groupManager.registerPoseable(this, "pickup"));
	}

	@Override
	public void moveTo(Vector2 worldSpacePoint) {
		setM_locX((int)worldSpacePoint.getX());
		setM_locY((int)worldSpacePoint.getY());
		
	}

	@Override
	public Vector2 getPosition() {
		return new Vector2(this.getM_locX() + width/2.0f, this.getM_locY() + height/2.0f);
	}

	@Override
	public WorldFeature getFeature() {
		return position;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <ValueType extends Value> ValueType getFeatureValue() {
		return (ValueType) new Vector2Wrapper(getPosition());
	}

	@Override
	public Iterable<Group> getGroups() {
		return groups;
	}

	@Override
	public void setWidthAndHeight(Game init) {
		Vector2 widthVec = init.getWorldSpacePoint(new Vector2(0, 0).subtract(new Vector2(((AIPaintPacMan)init).getGameUI().getCELL_LENGTH(), 0)));
		width = -widthVec.getX();
		height = width;	
		
	}

	@Override
	public Vector2 getOrientation() {
		if(m_direction == UP) {
			return Vector2.UP;
		} else if (m_direction == RIGHT) {
			return Vector2.RIGHT;
		} else if (m_direction == DOWN) {
			return Vector2.DOWN; 
		} else {
			return Vector2.LEFT;
		}
	}
	
	@Override
	public WorldFeature getOrientationFeature() {
		return orientation;
	}
	
	@Override
	public <ValueType extends Value> ValueType getOrientationFeatureValue() {
		return (ValueType) new Vector2Wrapper(getOrientation());
	}
}
