package aiPaintPacMan;

import java.util.LinkedList;

import pacman.GameModel;
import pacman.Player;
import edu.wpi.aipaint.main.Game;
import edu.wpi.aipaint.main.Group;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.main.WorldFeature;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Value;
import edu.wpi.aipaint.values.Vector2Wrapper;


public class PoseablePlayer extends Player implements Poseable, AiPacmanInitializable {
	private WorldFeature position, orientation;
	private float width, height;
	
	private LinkedList<Group> groups;

	public PoseablePlayer(GameModel gameModel, byte type, int startX, int startY, boolean bMiddleX) {
		super(gameModel, type, startX, startY, bMiddleX);
		position = new WorldFeature("PoseablePlayerPosition");
		orientation = new WorldFeature("PoseablePlayerOrientation");
		groups = new LinkedList<Group>();
	}
	
	@Override
	public void moveTo(Vector2 worldSpacePoint) {
		setM_locX((int) worldSpacePoint.getX());
		setM_locY((int) worldSpacePoint.getY());
	}
	
	@Override
	public Vector2 getPosition() {
		return new Vector2(this.getM_locX() + width/2.0f, this.getM_locY() + height/2.0f);
	}
	
	@Override
	public WorldFeature getFeature() {
		return position;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public <ValueType extends Value> ValueType getFeatureValue() {
		return (ValueType) new Vector2Wrapper(getPosition());
	}

	@Override
	public Iterable<Group> getGroups() {
		return groups;
	}
	
	public String toString() {
		return "PoseablePlayer";
	}
	
	@Override
	public void setWidthAndHeight(Game init) {
		//Vector2 widthVec = init.getWorldSpacePoint(new Vector2(0, 0).subtract(new Vector2(((AIPaintPacMan)init).getGameUI().getCELL_LENGTH(), 0)));
		width = ((AIPaintPacMan)init).getGameUI().getCELL_LENGTH() / 8;
		height = width;	
		
	}

	@Override
	public Vector2 getOrientation() {
		if(m_direction == UP) {
			return Vector2.UP;
		} else if (m_direction == RIGHT) {
			return Vector2.RIGHT;
		} else if (m_direction == DOWN) {
			return Vector2.DOWN; 
		} else {
			return Vector2.LEFT;
		}
	}
	
	@Override
	public WorldFeature getOrientationFeature() {
		return orientation;
	}
	
	@Override
	public <ValueType extends Value> ValueType getOrientationFeatureValue() {
		return (ValueType) new Vector2Wrapper(getOrientation());
	}

}
