package aiPaintPacMan;

import java.util.LinkedList;

import pacman.GameModel;
import pacman.PowerPellet;
import edu.wpi.aipaint.main.Game;
import edu.wpi.aipaint.main.Group;
import edu.wpi.aipaint.main.GroupManager;
import edu.wpi.aipaint.main.Poseable;
import edu.wpi.aipaint.main.WorldFeature;
import edu.wpi.aipaint.util.Vector2;
import edu.wpi.aipaint.values.Value;
import edu.wpi.aipaint.values.Vector2Wrapper;

public class PoseablePowerPellet extends PowerPellet implements Poseable, AiPacmanInitializable {
	int m_id;
	private WorldFeature position, orientation;
	private float width, height;
	
	private LinkedList<Group> groups;

	protected PoseablePowerPellet(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddleX, int iD) {
		super(gameModel, type, startX, startY, bMiddleX);

		this.m_id = iD;
		this.position = new WorldFeature("PoseablePowerPellet_" + m_id
				+ "_Position");
		this.orientation = new WorldFeature("PoseablePowerPellet_" + m_id
				+ "_Orientation");

		groups = new LinkedList<Group>();
		GroupManager groupManager = GroupManager.GetInstance();
		groups.add(groupManager.registerPoseable(this, "powerpellet"));
		groups.add(groupManager.registerPoseable(this, "pickup"));
	}

	@Override
	public void moveTo(Vector2 worldSpacePoint) {
		setM_locX((int) worldSpacePoint.getX());
		setM_locY((int) worldSpacePoint.getY());
	}

	@Override
	public Vector2 getPosition() {
		return new Vector2(this.getM_locX() + width/2.0f, this.getM_locY() + height/2.0f);
	}

	@Override
	public WorldFeature getFeature() {
		return position;
	}

	@SuppressWarnings("unchecked")
	@Override
	public <ValueType extends Value> ValueType getFeatureValue() {
		return (ValueType) new Vector2Wrapper(getPosition());
	}

	@Override
	public Iterable<Group> getGroups() {
		return groups;
	}
	
	@Override
	public void setWidthAndHeight(Game init) {
		width = ((AIPaintPacMan)init).getGameUI().getCELL_LENGTH() / 8;
		height = width;	
		
	}

	@Override
	public Vector2 getOrientation() {
		return Vector2.ZERO;
	}
	
	@Override
	public WorldFeature getOrientationFeature() {
		return orientation;
	}
	
	@Override
	public <ValueType extends Value> ValueType getOrientationFeatureValue() {
		return (ValueType) new Vector2Wrapper(getOrientation());
	}

}
