package aiPaintPacMan;

import java.awt.Color;

import pacman.Fruit;
import pacman.GameModel;
import pacman.Ghost;
import pacman.Player;
import pacman.PowerPellet;
import pacman.ThingFactory;

public class PoseableThingFactory extends ThingFactory {

	@Override
	public Fruit MakeFruit(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddleX) {
		return new PoseableFruit(gameModel, type, startX, startY, bMiddleX);
	}

	@Override
	public Ghost MakeGhost(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddle, Color color, int nExitMilliSec, int ID) {
		return new PoseableGhost(gameModel, type, startX, startY, bMiddle, color, 
				nExitMilliSec, ID);
	}

	@Override
	public Player MakePlayer(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddleX) {
		return new PoseablePlayer(gameModel, type, startX, startY, bMiddleX);
	}

	@Override
	public PowerPellet MakePowerPellet(GameModel gameModel, byte type,
			int startX, int startY, boolean bMiddleX, int iD) {
		return new PoseablePowerPellet(gameModel, type, startX, startY, bMiddleX, iD);
	}

}
