package pacman;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class PowerPellet extends Thing {
	PacMan m_pacMan;
    boolean m_bAvailable, m_bVisible;

    public PowerPellet(GameModel gameModel, byte type, int startX, int startY,
            boolean bMiddleX) {
        super(gameModel, type, startX, startY, bMiddleX);


        m_pacMan = gameModel.m_pacMan;
        this.setM_locX(startX);
        this.setM_locY(startY);
        m_bAvailable = true;
        m_bVisible = true;

    }

    @Override
    public void draw(GameUI gameUI, Graphics g) {
        if (!m_bVisible) {
            return;
        }
        if ((m_gameModel.m_pacMan.m_globalTickCount % (1000 / m_pacMan.m_delay)) > (200 / m_pacMan.m_delay)) {
            g.setColor(Color.pink);
        } else {
            g.setColor(Color.black);
        }

        g.fillOval(gameUI.getM_gridInset() + this.getM_locX() * gameUI.getCELL_LENGTH(),
                gameUI.getM_gridInset() + getM_locY() * gameUI.getCELL_LENGTH(), gameUI.getCELL_LENGTH(), gameUI.getCELL_LENGTH());

        //I don't like it here but it has nowhere else to go in this poorly planned code :/
        m_boundingBox.setBounds(gameUI.getM_gridInset() + getM_locX() * gameUI.getCELL_LENGTH(),
                gameUI.getM_gridInset() + getM_locY() * gameUI.getCELL_LENGTH(), gameUI.getCELL_LENGTH(), gameUI.getCELL_LENGTH());
    }

    // This method will check if the bounding box of the pellet intersects with
    // the bound box of the player.  If so, then player eats the pellet
    // return: 0 for no collision, 4 for ate the pellet
    public int checkCollision(Player player) {
        if (!m_bAvailable || !m_bVisible) {
            return 0;
        }

		Rectangle intersectRect;
        intersectRect = m_boundingBox.intersection(player.m_boundingBox);
        if (!intersectRect.isEmpty()) {
            this.m_bAvailable = false;
            this.m_bVisible = false;
            return 4;
        }
        return 0;
    }
}
