package pacman;

import java.awt.Color;

import aiPaintPacMan.PoseableThingFactory;

/**
 * This thing has a dependency on the aiPaintPacMan package, which should be
 * replaced with a dependency on the contents of a data file.
 * 
 * But Dave doesn't like reading and parsing files in Java, so for now IT STAYS.
 */
public abstract class ThingFactory
{
	private static ThingFactory instance;
	
	public static ThingFactory GetInstance()
	{
		if (instance == null)
			instance = new PoseableThingFactory();
		
		return instance;
	}
	
	public abstract PowerPellet MakePowerPellet(GameModel gameModel, byte type, int startX, 
			int startY, boolean bMiddleX, int iD);
	
	public abstract Player MakePlayer(GameModel gameModel, byte type, int startX, 
			int startY, boolean bMiddleX);
	
	public abstract Ghost MakeGhost(GameModel gameModel, byte type, int startX, 
			int startY, boolean bMiddle, Color color, int nExitMilliSec, int iD);
	
	public abstract Fruit MakeFruit(GameModel gameModel, byte type, int startX, 
			int startY, boolean bMiddleX);

	public Ghost MakeGhost(GameModel gameModel, byte type, int startX,
			int startY, boolean bMiddle, Color color, int nExitMilliSec) {
		return this.MakeGhost(gameModel, type, startX, startY, bMiddle, color, nExitMilliSec, -1);
	}
}
